if( Drupal.jsEnabled){
  Drupal.annotate_bl = function() { null;};

  Drupal.annotate_bl.rootNode= '#annotate-bl-source';

  Drupal.annotate_bl.fixDom= function( node){
    var root = $(node).get(0).childNodes;
    $(root).each( function(){
      if( this.nodeType==3){
        if( this.nodeValue.replace( /\W*/, '').length == 0){
          // TODO delete ?
        } else {
          $(this).wrap('<p>');
        }
      }
    });
  }

  /**
   * make the surroundings of the source text
   */  
  Drupal.annotate_bl.prepare= function(){
    node= Drupal.annotate_bl.rootNode;
    Drupal.annotate_bl.fixDom(node);

    $(node).children().addClass('annotate-source-block');
    $(node).children().wrap('<div class="annotate-wrap"></div>');
    
    $(node).children().each( function(i){ 
      $(this).prepend('<div class="annotate-link"><a class="annotate-link" target="_self" href="#bl_'+ i + '">'+i+'</a></div>');
    });
    
    $(node).children().prepend('<div class="annotate-comment-count">&nbsp;</div>');
    
    $('#annotate-bl-source').wrap('<div id="annotate-bl-app"></div>');
    
    // make elements active
    $('#annotate-bl-range-list').children('li').children('div').children('h3').click( function(){
      $(this).parent().children( '.annotate-bl-group').toggle();
    });

    $('div.annotate-comment-count').click( function(){
      Drupal.annotate_bl.show_editor( $(this).parent().children('.annotate-link').children('a').attr('href'));
    });
     
    $('.annotate-bl-list-item').hover(function () {
        $(this).addClass("hilite");
      }, function () {
        $(this).removeClass("hilite");
      }
    );
  }

  Drupal.annotate_bl.show_editor= function(block_number){
    alert( block_number);
  }
  
  Drupal.annotate_bl.fetch_annotations= function(){
    $('#annotate-bl-annotations').empty();
    
    $('#annotate-bl-annotations').append( '<ul id="annotate-bl-range-list"/>');

    $('#annotate-bl-range-list').append('<li class="annotation-comments annotations-page">' + 'Page'+ '</li>');
  
    $(Drupal.annotate_bl.rootNode).children().each( function(i){
      $('#annotate-bl-range-list').append('<li class="annotation-comments annotations-para">' + 'Paragraph '+ i + '</li>');
    });
    
    $('#annotate-bl-range-list').children().append( '<ul><li class="annotation-comment-fetching">fetching ...</li></ul>');
    $('#annotate-bl-range-list').children().children().hide();
    
    // callback to get comment counts
    // xyz()
    
    $('#annotate-bl-range-list').children().each( function(){
      $(this).click( function () {
        Drupal.annotate_bl.fetch_annotations_for_block( $(this));
      });
      
      $(this).hover(function () {
          $(this).addClass("hilite");
        }, function () {
          $(this).removeClass("hilite");
        }
      )
    });
  }
  
  Drupal.annotate_bl.fetch_annotations_for_block= function( list_item){
    $(list_item).children().toggle();
    if( $(list_item).children( 'ul').is(':visible')){
      // when made visible and still with fetching item get comments for block
      if( $(list_item).children( 'ul').children( 'li').is('.annotation-comment-fetching')){
        alert( 'fetching ... ');
        $(list_item).children( 'ul').empty();
        $(list_item).children( 'ul').append( '<div>annotation xyz</div>');
      }
    }
  }
  
}

$('document').ready( function(){
  Drupal.annotate_bl.prepare();
});

