if( Drupal.jsEnabled){
  Drupal.annotate = function() { null;};

  Drupal.annotate.rootNode= null;

  /* this should be done recursively to get into the correct
   * text node elements too.
   * probably use tree walker here
   */
	Drupal.annotate.fixDom= function( node){
	  var root = $(node).get(0).childNodes;
	  $(root).each( function(){
	    if( this.nodeType==3){
	      $(this).wrap('<span>');
	    }
	  });
	}

	/**
	 * sets the link value of the form
	 */	
	Drupal.annotate.setLinks= function(){
    var range = Drupal.annotate.getSelectionAsRange();
    if( range){
      $('#edit-path-start').val( Drupal.annotate.getRangeStartAsString( range, $('#annotate-ym-source')));
      $('#edit-path-stop').val(  Drupal.annotate.getRangeEndAsString( range, $('#annotate-ym-source')));
      $('#edit-title').val( Drupal.annotate.getSelectedText());
      
      Drupal.annotate.autoColorRange( range);
    };
	}
	
	var colors = [ '#F00', '#0F0', '#00F', '#FF0', '#0FF', '#F0F'];
	var color_index=0;
	
  Drupal.annotate.autoColorRange = function( range) {
    // http://developer.mozilla.org/en/docs/DOM:range.surroundContents
    var newNode = document.createElement("span");
    range.surroundContents(newNode);

    //Drupal.annotate.colorRange( range, colors[color_index++]);
    $(newNode).css( 'color', colors[color_index++]);
    color_index= color_index % colors.length;
  }
  
	Drupal.annotate.colorRange = function(range, color){
    Drupal.annotate.getElementsInRange( range).each( function(){ $(this).css( 'color' , color)});
	}

  Drupal.annotate.getElementsInRange = function(range) {
    var start= range.startContainer;
    var end= range.endContainer;

    function getSharedParent( node1, node2){
      if( node1==node2){
        return $(node1).parent();
      }
      
    	var tree1= $(node1).parents().get();
    	var tree2= $(node2).parents().get();

    	var common= tree1.pop();
    	var result= null;
    	
    	while( ( common!= undefined ) && (common == tree2.pop())){
      	result= common;
    	  common=tree1.pop();
    	}
    	return $(result);
    }  
    
    function acceptNode(node) {
      if( node != end){
        return NodeFilter.FILTER_ACCEPT;
      }
      return NodeFilter.FILTER_SKIP;
    };

    var sharedParent = getSharedParent( start, end).get()[0];
    
    var treeWalker = document.createTreeWalker( sharedParent, NodeFilter.SHOW_ELEMENT, acceptNode, true);

    var outArray = new Array();
    outArray.push( sharedParent);
    if (treeWalker) {
      var node = treeWalker.nextNode();
      while (node) {
        outArray.push(node);
        node = treeWalker.nextNode();
      }
    }
    return $(outArray);
  }

  /**
   * get the selection made by the user
   */
  Drupal.annotate.getSelection = function() {
	  var userSelection;
	
	  if (window.getSelection) {
		  userSelection = window.getSelection();
	  }
	  else if (document.selection) { // should come last; Opera!
		  userSelection = document.selection.createRange();
	  }
	  return userSelection;
	 };
	
	/**
	 * check the range start/end according to algorithme
	 *
	 * algorithme: do nothing
	 */
	Drupal.annotate.getSelectionAsRange = function(){
	  var selection = Drupal.annotate.getSelection();
	  var range = Drupal.annotate.getRangeObject( selection);
	  
	  return range;
	};

	/**
	 * get the selected text
	 */
	Drupal.annotate.getSelectedText = function(){
	  var selectedText = Drupal.annotate.getSelection();
	  
	  if (selectedText.text){
		  selectedText = selectedText.text;
		}
	  return selectedText;
	};
	
	/**
	 * get the range object
	 */
	Drupal.annotate.getRangeObject= function(selectionObject) {
		if (selectionObject.getRangeAt){
	    return selectionObject.getRangeAt(0);
	  }
		else { // Safari!
      // BUG: IE barks here ...
      // http://www.quirksmode.org/dom/range_intro.html
			var range = document.createRange();
			range.setStart(selectionObject.anchorNode,selectionObject.anchorOffset);
			range.setEnd(selectionObject.focusNode,selectionObject.focusOffset);
			return range;
		}
	};
	
  Drupal.annotate.getPathPart= function( node){
    return '/'+	node.tagName + '['+ $(node).parent().children().index(node) +']';
  }
    	
  Drupal.annotate.getParentPath= function( node, stopAt){
	  var path = '';
	  var list = null;
	  var skip= false;
    var result= Array();

    list= $(node).parents();
    for( var i=0; i< list.length; i++){
      if(!skip){
        skip = $(list[i]).get()[0]== $(stopAt).get()[0];
        result.push(Drupal.annotate.getPathPart( $(list[i]).get()[0]));
      }
    }

    result.reverse();
    path+= result.join('');
    
    return path;    
  }

  Drupal.annotate.getRangeStartAsString = function( range, stopAt){
	  var result= '';
	  var start= range.startContainer;

	  result+= Drupal.annotate.getParentPath( $(start), stopAt);
	  result+= ':'+ range.startOffset;

    return result;
  }

  Drupal.annotate.getRangeEndAsString = function( range, stopAt){
	  var result= '';
	  var end= range.endContainer;

	  result+= Drupal.annotate.getParentPath( $(end), stopAt);
	  result+= ':'+ range.endOffset;

    return result;
  }

	Drupal.annotate.getRangeAsString = function(){
	  var result= '[';
	  
	  var range = Drupal.annotate.getSelectionAsRange();
	  
    result +=	Drupal.annotate.getRangeStartAsString( range);
    result += ':';
    result +=	Drupal.annotate.getRangeEndAsString( range);

    result+= ']';
	  return result;
	};
	

}
